struct MF_results{
  float Lambda;  // Selection parameter
  float KL;      // KL from mutational distribution
  float lik;     // Likelihood of wild-type sequence
  float DG;      // Average DeltaG over sequence distribution 
  float Tf;      // Average Tf (?)
  float h;       // Protein average of site-specific average hydro
  float entropy; // Protein average of site-specific average entropy
  float rate;    // Protein average of site-specific average rate
  int conv;
};

int Fixed_Lambda(double *DG_ave, float **P_MF_ia, float *P_mut_a,
		 int **C_nat, int *i_sec, short *aa_seq,
		 struct REM E_wt, float Lambda, char *name_file);
int Optimize_Lambda(float *LAMBDA, double *DG_ave,
		    float **P_MF_ia, float *P_mut_a,
		    int **C_nat, int *i_sec, short *aa_seq,
		    struct REM E_wt, float DG_OPT, int GET_FREQ,
		    char *MODEL, char *name_file, FILE *file_summary);
int meanfield(float **P_MF_ia, struct MF_results *res,
	      float *P_mut_a, float **P_ini_ia,
	      int **C_nat, int *i_sec, int L,  float Lambda,
	      struct REM E_wt, int ALL); //Npop
void Divide_by_Pmut(float **P_MF_ia, float *P_mut_a, int L, int Naa);
float Compute_lik(float **P_MF_ia, int L, short *aa_seq);
void Copy_P(float **P1_ia, float **P2_ia, int L, int Naa);
void Compute_P_sel(float *P_sel, float **P_MF_ia, float *P_mut_a, int L);
float Find_max(float *y, float *x, int n, float MIN, float MAX);
void Test_distr(struct MF_results *MF_res,
		float **P_MF_ia, short *aa_seq, int L,
		int **C_nat, int *i_sec, struct REM E_wt);
float Hydro_ave(float **P_ia, float *hydro, int L);
void Print_results(struct MF_results res, char *what, FILE *file_out);
float KL(float *P, float *Q, int n); // Kullback-Leibler divergence
